;
; *****************************************************************************************************************
; ******************************************     Copyright Notice     *********************************************
; *                                                                                                               *
; *  This work was produced at the University of California, Lawrence Livermore National Laboratory (UC LLNL)     *
; *  under contract no. W-7405-ENG-48 (Contract 48) between the U.S. Department of Energy (DOE) and The Regents   *
; *  of the University of California (University) for the operation of UC LLNL. Copyright is reserved to the      *
; *  University for purposes of controlled dissemination, commercialization through formal licensing, or other    *
; *  disposition under terms of Contract 48; DOE policies, regulations and orders; and U.S. statutes. The rights  *
; *  of the Federal Government are reserved under Contract 48 subject to the restrictions agreed upon by the DOE  * 
; *  and University as allowed under DOE Acquisition Letter 97-1.                                                 *
; *                                                                                                               *
; *****************************************************************************************************************
;
; *****************************************************************************************************************
; **********************************************     DISCLAIMER     ***********************************************
; *                                                                                                               *
; *  This work was prepared as an account of work sponsored by an agency of the United States Government.         *
; *  Neither the United States Government nor the University of California nor any of their employees, makes      *
; *  any warranty, express or implied, or assumes any liability or responsibility for the accuracy, completeness, *
; *  or usefulness  *of any information, apparatus, product, or process disclosed, or represents that its use     *
; *  would not infringe privately-owned rights.  Reference herein to any specific commercial products, process,   *
; *  or service by trade name, trademark, manufacturer or otherwise does not necessarily constitute or imply its  *
; *  endorsement, recommendation, or favoring by the United States Government or the University of California.    *
; *  The views and opinions of authors expressed herein do not necessarily state or reflect those of the United   *
; *  States Government or the University of California, and shall not be used for advertising or product          *
; *  endorsement purposes.                                                                                        *
; *                                                                                                               *
; *****************************************************************************************************************
;

Pro GKV_Init, Thick=thickness, reverse=reverse
;
; Print Disclaimer
;
Disclaimer = STRARR(14)
Disclaimer[0] = " **********************************************     DISCLAIMER     ***********************************************"
Disclaimer[1] = " *                                                                                                               *"
Disclaimer[2] = " *  This work was prepared as an account of work sponsored by an agency of the United States Government.         *"
Disclaimer[3] = " *  Neither the United States Government nor the University of California nor any of their employees, makes      *"
Disclaimer[4] = " *  any warranty, express or implied, or assumes any liability or responsibility for the accuracy, completeness, *"
Disclaimer[5] = " *  or usefulness  of any information, apparatus, product, or process disclosed, or represents that its use      *"
Disclaimer[6] = " *  would not infringe privately-owned rights.  Reference herein to any specific commercial products, process,   *"
Disclaimer[7] = " *  or service by trade name, trademark, manufacturer or otherwise does not necessarily constitute or imply its  *"
Disclaimer[8] = " *  endorsement, recommendation, or favoring by the United States Government or the University of California.    *"
Disclaimer[9] = " *  The views and opinions of authors expressed herein do not necessarily state or reflect those of the United   *"
Disclaimer[10]= " *  States Government or the University of California, and shall not be used for advertising or product          *"
Disclaimer[11]= " *  endorsement purposes.                                                                                        *"
Disclaimer[12]= " *                                                                                                               *"
Disclaimer[13]= " *****************************************************************************************************************"
FOR i=0,13 DO Print, Disclaimer[i]

PRINT, "Initializing GKV Version 1.1"
; Start_up duties
;Device, Decomposed=0				; Use 8 bit color across all platforms
PLOT, FINDGEN(100)				;	(let's hope that we don't get reduced to this!)
reverse=1
IF(KEYWORD_SET(reverse)) THEN BEGIN
	Color_SetUp, 1, /REVERSE
ENDIF ELSE BEGIN
	Color_SetUp, 1
ENDELSE

!PROMPT = 'GKV>'				; Change Prompt to "GKV>"
;
; set forground and background colors (somehow, this doesn't get set by "Color_SetUp" ...)
;
!P.COLOR=1
!P.BACKGROUND=0
;
; Set line thickness for plots
;
thick = 1.
IF(N_ELEMENTS(thickness) NE 0) THEN thick = thickness
;
!P.THICK = thick				; Use wider lines in line plots
!X.THICK = thick				;   and for the x-axis,
!Y.THICK = thick				;   y-axis, and
!Z.THICK = thick				;   z-axis
!P.CHARTHICK = thick				;   and for 'drawing' characters
;
; Font defaults
;
!P.FONT=-1					; Use HERSHEY Vector fonts

RETURN
end
