FUNCTION GKVs1D::CHI_MIX, tauCorr, rho_star=rhoStar, NoErrorBars=noErrorBars
;
; Purpose:
;
;	This function computes the mixing length Chi (as a function of 
;	the inhomogeneous coordinate, 'r').  The radial correlation length
;	is assumed to be in 'self', while the argument is the correlation
;	time.  RhoStar used to correct the normalization.
;
; Written by W.M. Nevins
;	3/5/02
;
const=1.0
IF(N_ELEMENTS(rhoStar) EQ 1) THEN const=1./(rhoStar*rhoStar)
temp1=self -> times(self)
temp2=temp1 -> over(tauCorr)
result=temp2 -> times(const)

temp1 -> trash
temp2 -> trash

result.title='!4v!X!Dmix!N'
result.mnemonic = 'CHi_mix'
result.units = '!4q!X!S!Ds!U!R!U2!Nc!Ds!N/a'

IF(KEYWORD_SET(NoErrorBars)) THEN BEGIN
	PTR_FREE, result.ErrorBars
	result.ErrorBars = PTR_NEW()
ENDIF

return, result

END  ; ****** GKVs1D::CHI_MIX ******  ;