FUNCTION PorterData, arg, _Extra=Extra
;
; Make a GKV object from one of Gary's IDL data structures
;
; Written by W.M. Nevins
;   12/13/02
;
values=arg.data
t=arg.time
;
; Set some defaults
;

result=GetKeyWord('CodeName', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	codename='DIII-D'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		codename='DIII-D'
	ENDIF ELSE BEGIN
		IF(result NE '') THEN CodeName = result
	ENDELSE
ENDELSE

result=GetKeyWord('CodePI', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	codePI='G.D. Porter'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		codePI='G.D. Porter
	ENDIF ELSE BEGIN
		IF(result NE '') THEN CodePI = result
	ENDELSE
ENDELSE

result=GetKeyWord('gridmnemonic', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	gridmnemonic='t'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		gridmnemonic='t'
	ENDIF ELSE BEGIN
		IF(result NE '') THEN gridmnemonic = result
	ENDELSE
ENDELSE

result=GetKeyWord('gridtitle', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	gridtitle='t'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		gridtitle='t'
	ENDIF ELSE BEGIN
		IF(result NE '') THEN gridtitle = result
	ENDELSE
ENDELSE

result=GetKeyWord('gridunits', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	gridunits='ms'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		gridunits='ms'
	ENDIF ELSE BEGIN
		IF(result NE '') THEN gridunits = result
	ENDELSE
ENDELSE

result=GetKeyWord('gridBoundary', extra)
IF(TypeOF(result) NE 7) THEN BEGIN
	gridBoundary = 'open'
ENDIF ELSE BEGIN
	IF(result EQ 'undefined') THEN BEGIN
		gridBoundary = 'open'
	ENDIF ELSE BEGIN
		gridBoundary = result
	ENDELSE
ENDELSE



result = gkvs1D_MakeObj(/userinput, values=values, codeName=codeName, codePI=codePI,	$ 
			xvalues=t, gridmnemonic='t', gridtitle='t', gridunits='ms', 	$
			gridBoundary=gridBoundary, _EXTRA=extra)
			
result -> set, CodePI='G.D. Porter'
RETURN, result
END
