FUNCTION getBoutData, 	FileId=File_ID, dFileID = dFile_ID, runID=Run_ID, trange=t_range,	$
			MetricStr=MetricStr, R_jy=Rjy, niSpect = ni_Spect, Stick=Stick,		$
			nSep = n_Sep, rho_s=rhoIn, Omega_ci=omegaIn, a_mid=aMid

FileID = 'C-Mod Shot #1001020014 at 976 ms'
IF KEYWORD_SET(file_ID) THEN FileID=file_ID

dFileID = 'NAME?'
IF KEYWORD_SET(dFile_ID) THEN BEGIN
	fileID = fileID + ' ' + dFile_ID
	dFileID = dfile_ID
ENDIF

RunID = 'Outboard Midplane (jy=41)'
IF(N_ELEMENTS(Run_ID) NE 0) THEN runID=run_ID
boutStructure = NETCDF_DATA(path=work, arraystyle='c', runID=runID, FileID=FileID, Stick=stick)

IF(N_ELEMENTS(MetricStr) EQ 0) THEN BEGIN
	R_jy=8.924250e01
	IF(N_ELEMENTS(Rjy) EQ 1) THEN R_jy=Rjy
	nCmod, boutStructure, R_jy=R_jy
ENDIF ELSE BEGIN
	MetricTags = TAG_NAMES(MetricStr)
	nTags = N_TAGS(MetricStr)
;
; Get nSep from metric structure (if it's there)
;
	FOR i=0, nTags-1 DO BEGIN
		IF(STRCMP(MetricTags[i], 'nSep', /FOLD_CASE)) THEN BEGIN
			nSep = MetricStr.nsep
			GOTO, GotnSep
		ENDIF
	ENDFOR
	nSep = 19		; default value (correct for some C-Mod shots ...)
	IF(N_ELEMENTS(n_Sep) EQ 1) THEN nSep=n_Sep
GotnSep :
	BpBt=MetricStr.BpBt[nSep]
	q_jy=MetricStr.qSafe[nSep]
;
; Get R_jy from metric structure (if it's there)
;	
	FOR i=0, nTags-1 DO BEGIN
		IF(STRCMP(MetricTags[i], 'R_jy', /FOLD_CASE)) THEN BEGIN
			R_jy = MetricStr.R_jy
			GOTO, GotR_jy
		ENDIF
	ENDFOR
	R_jy=8.924250e01	; default value (correct for some C-Mod shots ...)
	IF(N_ELEMENTS(Rjy) EQ 1) THEN R_jy=Rjy
GotR_jy	:
;
; Get a_mid from metric structure (if it's there)
;	
	FOR i=0, nTags-1 DO BEGIN
		IF(STRCMP(MetricTags[i], 'a_mid', /FOLD_CASE)) THEN BEGIN
			a_mid = MetricStr.a_mid
			GOTO, Gota_mid
		ENDIF
	ENDFOR
	a_mid=29.09		; default value (correct for some C-Mod shots ...)
	IF(N_ELEMENTS(aMid) EQ 1) THEN a_mid=aMid
Gota_mid	:
;
; Get rho_s from metric structure (if it's there)
;	
	FOR i=0, nTags-1 DO BEGIN
		IF(STRCMP(MetricTags[i], 'rho_s', /FOLD_CASE)) THEN BEGIN
			rho_s = MetricStr.rho_s
			GOTO, GotRho_s
		ENDIF
	ENDFOR
	rho_s=0.0592858		; default value (correct for some C-Mod shots ...)
	IF(N_ELEMENTS(rhoIn) EQ 1) THEN rho_s=rhoIn
GotRho_s	:
;
; Get omega_ci from metric structure (if it's there)
;	
	FOR i=0, nTags-1 DO BEGIN
		IF(STRCMP(MetricTags[i], 'omega_ci', /FOLD_CASE)) THEN BEGIN
			omega_ci = MetricStr.omega_ci
			GOTO, GotOmega
		ENDIF
	ENDFOR
	omega_ci=1.99689e+08		; default value (correct for some C-Mod shots ...)
	IF(N_ELEMENTS(omegaIn) EQ 1) THEN omega_ci=omegaIn
GotOmega	:
	
	nCmod, boutStructure, 	xValues=MetricStr.x, SxHat=MetricStr.qInty, 	$
				BpBt=BpBt, q_jy=q_jy, R_jy=R_jy, rho_s=rho_s,	$
				Omega_ci=omega_ci, a_mid=a_mid
ENDELSE

boutStructure.ni -> set, title='n!Di!N', mnenonic='n_i', units='n_Di0!N'

nObjs = N_TAGS(boutStructure)

;trange = [3.5e-5, 8.7e-5]
IF(N_ELEMENTS(t_range) EQ 2) THEN BEGIN
	trange=t_range
	FOR i=0, nObjs-1 DO BEGIN
		boutStructure.(i) -> Signalwindow, t=trange
		boutStructure.(i) -> restrict
	ENDFOR
ENDIF

FOR i=0, nObjs-1 DO BEGIN
	boutStructure.(i) -> set, axis=2, boundary='periodic (closed)'
ENDFOR

output = CREATE_STRUCT('NAME', dFileID, boutStructure)

IF(KEYWORD_SET(ni_Spect)) THEN BEGIN
	niSpect = boutStructure.ni -> xspect()
	niSpect -> tokHz
	niSpect_x = niSpect -> avg(axis='k_x')
	output = CREATE_STRUCT(output, 'niSpect_x', niSpect_x)
ENDIF

RETURN, output

END ; ****** getBoutData ****** ;